## org.metaabm.gen.test
Class SpatialModel

    java.lang.Object
      org.ascape.model.AscapeObject
          org.ascape.model.Agent
              org.ascape.model.LocatedAgent
                  org.ascape.model.Cell
                      org.ascape.model.CellOccupant
                          org.ascape.model.Scape
                              org.metaabm.gen.test.SpatialModel

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, java.lang.Iterable, java.util.Collection, java.util.EventListener, ControlListener, ScapeListener, Location, Node, SpaceContext, HasName, RandomFunctions

    public class SpatialModel

extends Scape

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class org.ascape.model.Scape
`Scape.ConditionalIterator, Scape.DrawFeatureObservable`

Field Summary

Fields inherited from class org.ascape.model.Scape
`AGENT_ORDER, agentsPerIteration, ALL_AGENTS, CLEAR_STATS_RULE, COLLECT_STATS_RULE, COMPARE_ORDERED_QUALIFIERS, COMPLETE_TOUR, copyrightAndCredits, CREATE_GRAPHIC_VIEW_RULE, CREATE_RULE, CREATE_SCAPE_RULE, CREATE_VIEW_RULE, EXECUTE_RULES_RULE, INITIAL_RULES_RULE, initialRules, prototypeAgent, REPEATED_DRAW, RULE_ORDER, version`

Fields inherited from class org.ascape.model.CellOccupant
`PLAY_HOST_RULE, RANDOM_WALK_AVAILABLE_RULE`

Fields inherited from class org.ascape.model.Cell
`CALCULATE_NEIGHBORS_RULE, neighbors, PLAY_NEIGHBORS_RULE, PLAY_RANDOM_NEIGHBOR_RULE`

Fields inherited from class org.ascape.model.LocatedAgent
`agentSize, coordinate, MOVE_RANDOM_LOCATION_RULE, RANDOM_WALK_RULE, thisUpdate`

Fields inherited from class org.ascape.model.Agent
`DEATH_RULE, FISSIONING_RULE, FORCE_DIE_RULE, FORCE_FISSION_RULE, FORCE_MOVE_RULE, INITIALIZE_RULE, ITERATE_AND_UPDATE_RULE, ITERATE_RULE, METABOLISM_RULE, MOVEMENT_RULE, PLAY_OTHER, UPDATE_RULE`

Fields inherited from class org.ascape.model.AscapeObject
`ARBITRARY_SEED, name, PLATFORM_DEFAULT_COLOR, scape`

Constructor Summary
`SpatialModel()` Constructs a new Spatial Model.

Method Summary
`java.lang.Object` `clone()` Clones the agent, ensuring that a unique id is assigned.
`void` `createGraphicViews()` Creates UI views for Spatial Model.
`void` `createScape()` Creates the members of Spatial Model.
`void` `createUniqueID()`
`void` `dummy()`
`java.awt.Color` `getColor()` This agent's default color, used by many simple views.
`Scape` `getComplexLocation()` Gets the Complex Location property for Spatial Model.
`int` `getComplexLocationCount()` Gets the Complex Location Count property for Spatial Model.
`Scape` `getComplexMovementAgent()` Gets the Complex Movement Agent property for Spatial Model.
`int` `getComplexMovementAgentCount()` Gets the Complex Movement Agent Count property for Spatial Model.
`Scape` `getComplexNet()` Gets the Complex Net property for Spatial Model.
`double[]` `getGoodBoundary()` Gets the Good Boundary property for Spatial Model.
`Scape` `getGrid2D()` Gets the Grid 2D property for Spatial Model.
`int[]` `getGrid2DDimensions()` Gets the Dimensions property for Grid 2D.
`int` `getGrid2DHeight()` Gets the Height property for Grid 2D.
`int` `getGrid2DWidth()` Gets the Width property for Grid 2D.
`java.lang.String` `getName()` Returns the name of this scape, the model name if this is root and there is no name set.
`int` `getSpatialModelAgentCount()` Gets the Spatial Model Agent Count property for Spatial Model.
`java.lang.String` `getUID()`
`static void` `main(java.lang.String[] args)`
`void` `scapeSetup(ScapeEvent scapeEvent)` If the scape has delegated a view to itself, called each time a scape sends a "setup" method, indicating it needs to be setup for a run.
`void` `setComplexLocation(Scape _complexLocation)` Sets the Complex Location property for Spatial Model.
`void` `setComplexLocationCount(int _complexLocationCount)` Sets the Complex Location Count property for Spatial Model.
`void` `setComplexMovementAgent(Scape _complexMovementAgent)` Sets the Complex Movement Agent property for Spatial Model.
`void` `setComplexMovementAgentCount(int _complexMovementAgentCount)` Sets the Complex Movement Agent Count property for Spatial Model.
`void` `setComplexNet(Scape _complexNet)` Sets the Complex Net property for Spatial Model.
`void` `setGoodBoundary(double[] _goodBoundary)` Sets the Good Boundary property for Spatial Model.
`void` `setGrid2D(Scape _grid2D)` Sets the Grid 2D property for Spatial Model.
`void` `setGrid2DDimensions(int[] _grid2DDimensions)` Sets the Dimensions property for Grid 2D.
`void` `setGrid2DHeight(int _grid2DHeight)` Sets the Height property for Grid 2D.
`void` `setGrid2DWidth(int _grid2DWidth)` Sets the Width property for Grid 2D.
`void` `setSpatialModelAgentCount(int _spatialModelAgentCount)` Sets the Spatial Model Agent Count property for Spatial Model.

Methods inherited from class org.ascape.model.Scape

`add, add, add, add, addAll, addDrawFeature, addInitialRule, addInitialRule, addRule, addRule, addScapeListener, addScapeListenerFirst, addStatCollector, addStatCollectorIfNew, addStatCollectors, addView, addView, addView, addViews, addViews, addViews, assignParameters, assignParameters, calculateDistance, calculateDistance, clear, construct, contains, containsAll, contentsToString, countWithin, createNonGraphicViews, createSelfView, createViews, createViews, environmentQuiting, execute, execute, executeOnMembers, executeOnMembers, executeOnMembers, executeOnMembers, executeOnRoot, executeOnRoot, find, findMaximum, findMaximum, findMaximumWithin, findMinimum, findMinimum, findMinimumWithin, findNearest, findRandom, findRandom, findRandom, findRandomCoordinate, findWithin, get, get, getAgentsPerIteration, getAllScapes, getCollectStats, getData, getDescription, getDrawFeatures, getDrawFeaturesObservable, getEnvironment, getExecutionOrder, getExecutionStyle, getExtent, getHome, getHTMLDescription, getInitialRules, getIteration, getIterationsPerRedraw, getModel, getPausePeriod, getPeriod, getPeriodDescription, getPeriodName, getPrototype, getPrototypeAgent, getRoot, getRules, getRunner, getScapeListeners, getSize, getSpace, getStartPeriod, getStatCollectors, getStopPeriod, getSuperScape, getThreadCount, getUIEnvironment, getUserEnvironment, hasWithin, initialize, isAllViewsUpdated, isAutoCreate, isCellsRequestUpdates, isEmpty, isGraphic, isHome, isLifeOfScape, isListenersAndMembersCurrent, isMembersActive, isMutable, isPaused, isPeriodic, isPopulateOnCreate, isRoot, isRunning, isScapeListener, isSerializable, isStartOnOpen, isUpdateNeeded, isValidPeriod, isViewSelf, iterator, listenerOrMemberUpdated, listenerUpdated, memberUpdated, moveAway, moveToward, newAgent, newAgent, notifyViews, notifyViews, populate, remove, remove, removeAll, removeDrawFeature, removeScapeListener, respondControl, respondDrawFeature, retainAll, retrieveAllAccessors, retrieveAllAccessorsOrdered, retrieveModelAccessorsOrdered, save, save, scapeAdded, scapeClosing, scapeDeserialized, scapeInitialized, scapeIterated, scapeIterator, scapeIterator, scapeIterators, scapeNotification, scapeRandomIterator, scapeRemoved, scapeStarted, scapeStopped, search, searchMax, searchMin, set, set, set, set, setAgentsPerIteration, setAutoCreate, setAutoRestart, setCellsRequestUpdates, setCollectStats, setCollectStats, setDescription, setEarliestPeriod, setExecutionOrder, setExecutionStyle, setExtent, setExtent, setExtent, setHome, setHTMLDescription, setInitialRules, setIterationsPerRedraw, setIterationsPerRedraw, setLatestPeriod, setMembersActive, setPaused, setPausePeriod, setPeriodic, setPeriodName, setPopulateOnCreate, setPrototypeAgent, setRunner, setRunning, setSerializable, setSize, setSpace, setStartOnOpen, setStartPeriod, setStopPeriod, setSuperScape, setThreadCount, setViewSelf, size, toArray, toArray, toString, withinIterator`

Methods inherited from class org.ascape.model.CellOccupant

`die, findAvailableNeighbors, findNearest, findNearest, findNearest, findNearest, findNearest, findNeighbors, findNeighborsOnHost, findRandomAvailableNeighbor, findRandomNeighbor, findRandomNeighborOnHost, findWithin, findWithin, findWithin, getCoordinate, getHostCell, getHostScape, leave, moveAway, moveTo, moveToRandomLocation, moveToward, playNeighbors, playRandomNeighbor, randomWalk, randomWalkAvailable, setHostCell, setHostScape`

Methods inherited from class org.ascape.model.Cell
`calculateNeighbors, countNeighbors, findOccupants, findRelative, getDistance, getNeighbors, getNeighbors, getNetwork, getOccupant, hostedCondition, isAvailable, removeOccupant, setNeighbors, setNeighborsList, setNetwork, setOccupant`

Methods inherited from class org.ascape.model.LocatedAgent
`calculateDistance, calculateDistance, countWithin, countWithin, countWithin, findMaximumWithin, findWithin, getAgentSize, hasWithin, hasWithin, hasWithin, isUpdateNeeded, moveAway, moveAway, moveTo, moveToward, moveToward, requestUpdate, requestUpdateNext, setAgentSize, setCoordinate`

Methods inherited from class org.ascape.model.Agent
`clearDeleteMarker, death, deathCondition, execute, execute, fission, fissionCondition, fissioning, getColor, getImage, getImage, getPlatformColor, isDelete, isInitialized, iterate, markForDeletion, metabolism, move, movement, movementCondition, play, scapeCreated, setInitialized, setScape, update`

Methods inherited from class org.ascape.model.AscapeObject
`diffDeep, diffDeep, diffDeepBFS, diffDeepDFS, diffDeepValidate, diffDeepVisit, equalsDeep, equalsDeep, equalsDeep, getComparisonStream, getRandom, getRandomSeed, getScape, randomInRange, randomInRange, randomIs, randomToLimit, reseed, setComparisonStream, setName, setRandom, setRandomSeed`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`equals, hashCode`

Methods inherited from interface org.ascape.model.event.ScapeListener
`getScape`

Methods inherited from interface org.ascape.model.space.Location
`clearDeleteMarker, isDelete, markForDeletion, setCoordinate`

Constructor Detail

### SpatialModel

    public SpatialModel()

  Constructs a new Spatial Model.

Method Detail

### getUID

    public java.lang.String getUID()

### createUniqueID

    public void createUniqueID()

### clone

    public java.lang.Object clone()

  Clones the agent, ensuring that a unique id is assigned.

  Specified by:
    `clone` in interface `ScapeListener`
  Specified by:
    `clone` in interface `Location`
  Overrides:
    `clone` in class `Scape`
  Returns:
    the object

### dummy

    public void dummy()

### getComplexMovementAgent

    public Scape getComplexMovementAgent()

  Gets the Complex Movement Agent property for Spatial Model.

  Returns:

### setComplexMovementAgent

    public void setComplexMovementAgent(Scape _complexMovementAgent)

  Sets the Complex Movement Agent property for Spatial Model.

  Parameters:
    `_complexMovementAgent` - the new Complex Movement Agent value

### getComplexLocation

    public Scape getComplexLocation()

  Gets the Complex Location property for Spatial Model.

  Returns:

### setComplexLocation

    public void setComplexLocation(Scape _complexLocation)

  Sets the Complex Location property for Spatial Model.

  Parameters:
    `_complexLocation` - the new Complex Location value

### createScape

    public void createScape()

  Creates the members of Spatial Model.

  Overrides:
    `createScape` in class `Scape`
  See Also:
    `Scape.setPopulateOnCreate(boolean)`

### createGraphicViews

    public void createGraphicViews()

  Creates UI views for Spatial Model.

  Overrides:
    `createGraphicViews` in class `Scape`

### scapeSetup

    public void scapeSetup(ScapeEvent scapeEvent)

  Description copied from class: `Scape`
  If the scape has delegated a view to itself, called each time a scape sends a "setup" method, indicating it needs to be setup for a run. Possible uses include setting initial vector extents, responding to changes in user settings, and changing parameters systematically. (A view delegate to the scape is automatically created for root scapes when the standard model implementation is used.)

  Specified by:
    `scapeSetup` in interface `ScapeListener`
  Overrides:
    `scapeSetup` in class `Scape`
  Parameters:
    `scapeEvent` - the associated scape event

### main

    public static void main(java.lang.String[] args)

### getColor

    public java.awt.Color getColor()

  Description copied from class: `Agent`
  This agent's default color, used by many simple views. Black is default; override to provide an appropriate color.

  Overrides:
    `getColor` in class `Agent`

### getComplexMovementAgentCount

    public int getComplexMovementAgentCount()

  Gets the Complex Movement Agent Count property for Spatial Model.

  Returns:
    The number of complex movement agents to create.

### setComplexMovementAgentCount

    public void setComplexMovementAgentCount(int _complexMovementAgentCount)

  Sets the Complex Movement Agent Count property for Spatial Model. The number of complex movement agents to create.

  Parameters:
    `_complexMovementAgentCount` - the new Complex Movement Agent Count value

### getComplexLocationCount

    public int getComplexLocationCount()

  Gets the Complex Location Count property for Spatial Model.

  Returns:
    The number of complex locations to create.

### setComplexLocationCount

    public void setComplexLocationCount(int _complexLocationCount)

  Sets the Complex Location Count property for Spatial Model. The number of complex locations to create.

  Parameters:
    `_complexLocationCount` - the new Complex Location Count value

### getSpatialModelAgentCount

    public int getSpatialModelAgentCount()

  Gets the Spatial Model Agent Count property for Spatial Model.

  Returns:
    The number of spatial model agents to create.

### setSpatialModelAgentCount

    public void setSpatialModelAgentCount(int _spatialModelAgentCount)

  Sets the Spatial Model Agent Count property for Spatial Model. The number of spatial model agents to create.

  Parameters:
    `_spatialModelAgentCount` - the new Spatial Model Agent Count value

### getGoodBoundary

    public double[] getGoodBoundary()

  Gets the Good Boundary property for Spatial Model.

  Returns:

### setGoodBoundary

    public void setGoodBoundary(double[] _goodBoundary)

  Sets the Good Boundary property for Spatial Model.

  Parameters:
    `_goodBoundary` - the new Good Boundary value

### getGrid2DDimensions

    public int[] getGrid2DDimensions()

  Gets the Dimensions property for Grid 2D.

  Returns:
    The size of each dimension.

### setGrid2DDimensions

    public void setGrid2DDimensions(int[] _grid2DDimensions)

  Sets the Dimensions property for Grid 2D. The size of each dimension.

  Parameters:
    `_grid2DDimensions` - the new Dimensions value

### getGrid2DWidth

    public int getGrid2DWidth()

  Gets the Width property for Grid 2D.

  Returns:
    The horizontal extent of the space.

### setGrid2DWidth

    public void setGrid2DWidth(int _grid2DWidth)

  Sets the Width property for Grid 2D. The horizontal extent of the space.

  Parameters:
    `_grid2DWidth` - the new Width value

### getGrid2DHeight

    public int getGrid2DHeight()

  Gets the Height property for Grid 2D.

  Returns:
    The vertical extent of the space.

### setGrid2DHeight

    public void setGrid2DHeight(int _grid2DHeight)

  Sets the Height property for Grid 2D. The vertical extent of the space.

  Parameters:
    `_grid2DHeight` - the new Height value

### getGrid2D

    public Scape getGrid2D()

  Gets the Grid 2D property for Spatial Model.

  Returns:

### setGrid2D

    public void setGrid2D(Scape _grid2D)

  Sets the Grid 2D property for Spatial Model.

  Parameters:
    `_grid2D` - the new Grid 2D value

### getComplexNet

    public Scape getComplexNet()

  Gets the Complex Net property for Spatial Model.

  Returns:

### setComplexNet

    public void setComplexNet(Scape _complexNet)

  Sets the Complex Net property for Spatial Model.

  Parameters:
    `_complexNet` - the new Complex Net value

### getName

    public java.lang.String getName()

  Description copied from class: `Scape`
  Returns the name of this scape, the model name if this is root and there is no name set.

  Specified by:
    `getName` in interface `SpaceContext`
  Specified by:
    `getName` in interface `HasName`
  Overrides:
    `getName` in class `Scape`
  Returns:
    the name